package backend;

import frontend.Token;

import java.util.ArrayList;

/**
 * Global built-in Scheme procedures implemented in Java.
 */
public class BuiltIn 
{
    /**
     * Evaluate a built-in procedure.
     * @param procToken the procedure's token taken from a tree node.
     * @param args the array list of arguments.
     * @return the value from executing the procedure.
     */
    public static Object eval(Token procToken, ArrayList<Object> args)
    {
        String text = procToken.getText();
        
        // Addition + procedure.
        if (text.equals("+")) {
            float sum = 0;
            for (Object arg : args) {
                sum += (Float) arg;
            }
            return sum;
        }
        
        // Multiplication * procedure.
        else if (text.equals("*")) {
            float product = 1;
            for (Object arg : args) {
                product *= (Float) arg;
            }
            return product;
        }
        
        return null;
    }
}
