package intermediate;

import frontend.Token;

/**
 * Schemer parse tree node.
 */
public class Node 
{
    private NodeType type;            // type
    private Token token;              // token
    private SymbolTable symtab;       // symbol table
    private SymtabEntry symtabEntry;  // symbol table entry
    private Node car;                 // left child
    private Node cdr;                 // right child
    
    /**
     * Constructor of a list node.
     */
    public Node()
    {
        this.type        = NodeType.LIST;
        this.token       = null;
        this.symtab      = null;
        this.symtabEntry = null;
        this.car         = null;
        this.cdr         = null;
    }
    
    /**
     * Constructor of an element node.
     * @param token the element token.
     */
    public Node(Token token)
    {
        this.type        = NodeType.ELEMENT;
        this.token       = token;
        this.symtab      = null;
        this.symtabEntry = null;
        this.car         = null;
        this.cdr         = null;
    }

    public NodeType    getType()        { return type; }
    public Token       getToken()       { return token; }
    public SymbolTable getSymtab()      { return symtab; }
    public SymtabEntry getSymtabEntry() { return symtabEntry; }
    public Node        car()            { return car;  }
    public Node        cdr()            { return cdr;  }
    
    public void setSymtab(SymbolTable symtab)     { this.symtab = symtab; }
    public void setSymtabEntry(SymtabEntry entry) { this.symtabEntry = entry; }
    public void setCar(Node left)                 { this.car = left;  }
    public void setCdr(Node right)                { this.cdr = right; }
}
