package intermediate;

import java.util.ArrayList;


/**
 * Results returned from the parser to be handed to the backend executor.
 */
public class ParserResults 
{
    private SymbolTable symtabTopLevel;
    private ArrayList<Node> trees;
    
    /**
     * Constructor.
     * @param symtabTopLevel the top-level symbol table.
     * @param trees the array list of top-level trees.
     */
    public ParserResults(SymbolTable symtabTopLevel, ArrayList<Node> trees)
    {
        this.symtabTopLevel = symtabTopLevel;
        this.trees = trees;
    }
    
    public SymbolTable getSymtabTopLevel() { return this.symtabTopLevel; }
    public ArrayList<Node> getTrees()      { return this.trees; }
}
